<?php

require_once('../model/LOUserModel.php');//any model classes being used
require_once('BackEndController.php');//any other controllers being invoked

//handles complexities of logging into backend
class BackLoginController 
{
    
    private $model;
    
    public function __construct()
    {
        $this->model = new LOUserModel();
    }
    
    public function invoke()
    {
        session_start();
        $_SESSION['auth'] = false;

        $msg = "";//holds login error messages
        $userName = "";
        $password = "";
        
        if (!empty($_POST['userName']) && !empty($_POST['password']))
        {
            $userName = $_POST['userName'];
            $password = $_POST['password'];
            $utype = "BACK";//to tell the model what kind of login we're trying to do
            //now go find the user
            $authresult = $this->model->matchUser($userName,$password,$utype);
            //[0] couldn't find; [1] good; [2] not authorized; [-1] passwd didn't match
            switch ($authresult) {
                case 0:
                    $msg = "Sorry, there is no such user.";
                    break;
                case 1:
                    $_SESSION['auth'] = true;
                    $_SESSION['user'] = $userName;
                       //switch to backend controller
                       $backEndController = new BackEndController();
                       $backEndController->invoke();
                    break;
                case 2:
                    $msg = "Sorry, you are not authorized to use CManager.";
                    break;
                case -1:
                    $msg = "Password did not match.";
                    break;
                default:
                    $msg = "Something weird happened.";
            }

        }
        else if (!empty($_POST['submit'])){
            
                 $msg = "You must supply both username and password.";
                        if (!empty($_POST['userName']))
                    {
                        $userName = $_POST['userName'];
                    }

        }
        if (!$_SESSION['auth'])//if not authorized (yet), show login page
        {
        include '../view/cmanager/login.phtml';    
        }
    }
        

}

?>
