<?php

require_once 'Article.php';

require_once 'data/MySQLFrontEndDataModel.php';

//frontend db <> article model
class FEArticleModel 
{
    private $m_DataAccess;
    
    public function __construct()
    {
        $this->m_DataAccess = new MySQLFrontEndDataModel();
    }
    
    public function __destruct()
    {
        // not doing anything at the moment
    }
    
    //get article by its name (for editing)
    public function fetchArticle($articleID)
    {
        $article = new Article();
        $this->m_DataAccess->connectToDB();
        $articleRecord = $this->m_DataAccess->selectArticle($articleID);
        $article->setName($articleRecord['name']);
        $article->setTitle($articleRecord['title']);
        $article->setDescription($articleRecord['description']);
        $article->setPage($articleRecord['page']);
        $article->setArea($articleRecord['area']);
        $article->setBody($articleRecord['body']);
        return $article;
    }
            
    //get articles corresponding to a particular page
    public function fetchArticles($pageID)
    {
        $articlesArray = array();
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->selectArticles($pageID);
        while($row = $this->m_DataAccess->fetchArticles())
        {
            $currentArticle = new Article();
            $currentArticle->setName($row['name']);
            $currentArticle->setTitle($row['title']);
            $currentArticle->setDescription($row['description']);
            $currentArticle->setPage($row['page']);
            $currentArticle->setArea($row['area']);
            $currentArticle->setBody($row['body']);
            $currentArticle->setCreate_by($row['create_by']);
            $currentArticle->setCreate_dt($row['create_dt']);
            $currentArticle->setMod_by($row['mod_by']);
            $currentArticle->setMod_dt($row['mod_dt']);
            $articlesArray[] = $currentArticle;
        }
        return $articlesArray;
    }
    
    //edit existing article record
    public function editArticle($who,$oname,$name,$title,$description,$page,$area,$body)
    {
        $editArticle = new Article();
        
        $editArticle->setName($name);
        $editArticle->setTitle($title);
        $editArticle->setDescription($description);
        $editArticle->setPage($page);
        $editArticle->setArea($area);
        $editArticle->setBody($body);
        
        //save the edited article to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->updateArticle($who, $oname, $editArticle);
        return;
    }
    
    //insert new article record
    public function insertArticle($who,$name,$title,$description,$page,$area,$body)
    {
        
        $newArticle = new Article();
        $newArticle->setName($name);
        $newArticle->setTitle($title);
        $newArticle->setDescription($description);
        $newArticle->setPage($page);
        $newArticle->setArea($area);
        $newArticle->setBody($body);
        
        //save the new article to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->saveNewArticle($who,$newArticle);
        return;
    }
    
}

?>
